/*===========================================================================

	Copyright  2007 Tea Tuar

	This material is provided "as is", with no warranty expressed or implied.
	Any use is at your own risk. Permission to use or copy this software for
	any purpose is hereby granted without fee, provided this notice is
	retained on all copies. Permission to modify the code and to distribute
	modified code is granted, provided a notice that the code was modified is
	included with the above copyright notice.

	http://dis.ijs.si/tea/research.htm

	===========================================================================

	Implementation file.

	file: demo_utilities.cpp
	author: Tea Tusar (tea.tusar@ijs.si)
	created: 19.02.2006
	last change: $date$

	===========================================================================
*/

#include "demo_utilities.h"
//---------------------------------------------------------------------------

vector<UINT> GetSorted(vector<double> &values)
{
	vector<UINT> result;
	result.clear();
	list<DemoSortItem> sort_list;

	for (UINT i = 0; i < values.size(); i++)
		sort_list.push_back(DemoSortItem(i, values.at(i)));
	sort_list.sort();

	for (UINT i = 0; i < values.size(); i++) {
		result.push_back(sort_list.front().m_index);
		sort_list.pop_front();
	}

	return result;
}
//---------------------------------------------------------------------------

E::E(string arg)
	: error(arg)
{

}
//---------------------------------------------------------------------------

void my_terminate() {
	cerr << "DEMO will terminate!";
}
//---------------------------------------------------------------------------

string GetBoolStringYN(bool x)
{
	return (x ? "yes" : "no");
}
//---------------------------------------------------------------------------

string GetBoolString01(bool x)
{
	return (x ? "1" : "0");
}
//---------------------------------------------------------------------------

unsigned long random(unsigned long x) {
	return rand()%x;
}
//---------------------------------------------------------------------------

